%% Square Wave Fourier Coefficients

d = 0.50; % duty cycle
coeff = @(k) d*sinc(k*d);
M = 11;
yc = zeros(M,1);
idx = 1:2:M;
load square.mat
fprintf('%2s %10s %10s %8s %8s\n','k','ck (V)','ck (dB)','calc (dB)','meas (dB)');
for k=idx
    c = abs(coeff(k));
    yc(k) = 20*log10(c);
    fprintf('%2d %10g  %10g %8g %8g\n',k,c,yc(k),yc(k)-yc(1),y(k)-y(1));
end
stem(idx,yc(idx)-yc(1)+35);
hold on;
plot(idx,y(idx)-y(1)+35,'kx','MarkerSize',16);
hold off;
xlabel('harmonic');
ylabel('dB');
axis([0 M+1 0 40]);